/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package BlockWar;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.event.MouseEvent;
import java.util.Calendar;

/**
 *
 * @author Fabi
 */
public class ReflectionBlock extends Block {

    private int lifes = 1;
    private long startTime = -1;

    @Override
    public void onCollision(GameObject o) {
        if (o instanceof Moveable) {
            Moveable m = (Moveable) o;
            m.setXVelocity(-m.getXVelocity());
            m.setYVelocity(-m.getYVelocity());
            if (lifes-- <= 0) {
                GameObject.eraseLater(this);
            }
        }
    }

    @Override
    public void paintObject(Graphics2D g2d) {
        super.paintObject(g2d);
        g2d.setColor(Color.BLACK);
        g2d.drawString("" + lifes,
                (int) getPosition().getX(), (int) getPosition().getY());
    }

    @Override
    public void mousePressed(MouseEvent e) {
        if (this.contains(e.getPoint())) {
            startTime = Calendar.getInstance().getTimeInMillis();
        }
    }

    @Override
    public void mouseReleased(MouseEvent e) {
        if (this.contains(e.getPoint())) {
            long diffTime =
                    Calendar.getInstance().getTimeInMillis() - startTime;
            diffTime /= 500; // in seconds / 2
            lifes += diffTime;
        }
        startTime = -1;
    }

    @Override
    public void init() {
        super.init();
        setColor(Color.BLUE);
    }
}
