/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package BlockWar;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.Image;
import java.io.File;
import javax.imageio.ImageIO;

/**
 *
 * @author Fabi
 */
public abstract class SideBlock extends Block {

    private static final float VELOCITY = 10;

    /**
     * @return the side
     */
    public Side getSide() {
        return side;
    }

    /**
     * @param side the side to set
     */
    public void setSide(Side side) {
        this.side = side;
    }

    public enum Side {

        UP,
        DOWN,
        RIGHT,
        LEFT
    }

    @Override
    public void paintObject(Graphics2D g2d) {
        super.paintObject(g2d);
        String filename = null;
        switch (side) {
            case UP:
                filename = "up.gif";
                break;
            case DOWN:
                filename = "down.gif";
                break;
            case LEFT:
                filename = "left.gif";
                break;
            case RIGHT:
                filename = "right.gif";
                break;
        }
        Image img = null;
        try {
            img =
                    ImageIO.read(new File(filename));
        } catch (Exception ex) {
            ex.printStackTrace();
            System.exit(1);
        }
        g2d.drawImage(img,
                (int)getPosition().getX(), (int)getPosition().getY(), null);
    }
    private Side side;

    @Override
    public void onCollision(GameObject o) {
        if (o instanceof Moveable) {
            Moveable m = (Moveable) o;
            m.setXVelocity(0);
            m.setYVelocity(0);
            switch (side) {
                case UP:
                    m.setYVelocity(-VELOCITY);
                    break;
                case DOWN:
                    m.setYVelocity(VELOCITY);
                    break;
                case RIGHT:
                    m.setXVelocity(VELOCITY);
                    break;
                case LEFT:
                    m.setXVelocity(-VELOCITY);
                    break;
            }
            GameObject.eraseLater(this);
        }
    }

    @Override
    public void init() {
        super.init();
        setColor(Color.RED);
    }
}
